Index: LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1795)
@@ -1824,11 +838,11 @@
     ecrit_ins = ecrit_files(6)
 
-    write(lunout,*)'swaero_diag=',swaero_diag
-    write(lunout,*)'Fin phys_output_mod.F90'
-  end subroutine phys_output_open
-
-  SUBROUTINE histdef2d (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
-
-    use ioipsl
+    WRITE(lunout,*)'swaero_diag=',swaero_diag
+    WRITE(lunout,*)'Fin phys_output_mod.F90'
+  end SUBROUTINE phys_output_open
+
+  SUBROUTINE histdef2d_old (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
+
+    USE ioipsl
     USE dimphy
     USE mod_phys_lmdz_para
@@ -1837,52 +851,51 @@
     IMPLICIT NONE
 
-    include "dimensions.h"
-    include "temps.h"
-    include "indicesol.h"
-    include "clesphys.h"
-
-    integer                          :: iff
-    logical                          :: lpoint
-    integer, dimension(nfiles)       :: flag_var
-    character(len=20)                 :: nomvar
-    character(len=*)                 :: titrevar
-    character(len=*)                 :: unitvar
-
-    real zstophym
-
-    if (type_ecri(iff)=='inst(X)'.OR.type_ecri(iff)=='once') then
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    LOGICAL                          :: lpoint
+    INTEGER, DIMENSION(nfiles)       :: flag_var
+    CHARACTER(LEN=20)                 :: nomvar
+    CHARACTER(LEN=*)                 :: titrevar
+    CHARACTER(LEN=*)                 :: unitvar
+
+    REAL zstophym
+
+    IF (type_ecri(iff)=='inst(X)'.OR.type_ecri(iff)=='once') THEN
        zstophym=zoutm(iff)
-    else
+    ELSE
        zstophym=zdtime
-    endif
+    ENDIF
 
     ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
-    call conf_physoutputs(nomvar,flag_var)
-
-    if(.NOT.lpoint) THEN  
-       if ( flag_var(iff)<=lev_files(iff) ) then
-          call histdef (nid_files(iff),nomvar,titrevar,unitvar, &
+    CALL conf_physoutputs(nomvar,flag_var)
+
+    IF(.NOT.lpoint) THEN  
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff),nomvar,titrevar,unitvar, &
                iim,jj_nb,nhorim(iff), 1,1,1, -99, 32, &
                type_ecri(iff), zstophym,zoutm(iff))                
-       endif
-    else
-       if ( flag_var(iff)<=lev_files(iff) ) then
-          call histdef (nid_files(iff),nomvar,titrevar,unitvar, &
+       ENDIF
+    ELSE
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff),nomvar,titrevar,unitvar, &
                npstn,1,nhorim(iff), 1,1,1, -99, 32, &
                type_ecri(iff), zstophym,zoutm(iff))                
-       endif
-    endif
+       ENDIF
+    ENDIF
 
     ! Set swaero_diag=true if at least one of the concerned variables are defined 
-    if (nomvar=='topswad' .OR. nomvar=='topswai' .OR. nomvar=='solswad' .OR. nomvar=='solswai' ) THEN
-       if  ( flag_var(iff)<=lev_files(iff) ) then
+    IF (nomvar=='topswad' .OR. nomvar=='topswai' .OR. nomvar=='solswad' .OR. nomvar=='solswai' ) THEN
+       IF  ( flag_var(iff)<=lev_files(iff) ) THEN
           swaero_diag=.TRUE.
-       end if
-    end if
-  end subroutine histdef2d
-
-  SUBROUTINE histdef3d (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
-
-    use ioipsl
+       END IF
+    END IF
+  END SUBROUTINE histdef2d_old
+
+  SUBROUTINE histdef2d (iff,var)
+
+    USE ioipsl
     USE dimphy
     USE mod_phys_lmdz_para
@@ -1891,43 +904,167 @@
     IMPLICIT NONE
 
-    include "dimensions.h"
-    include "temps.h"
-    include "indicesol.h"
-    include "clesphys.h"
-
-    integer                          :: iff
-    logical                          :: lpoint
-    integer, dimension(nfiles)       :: flag_var
-    character(len=20)                 :: nomvar
-    character(len=*)                 :: titrevar
-    character(len=*)                 :: unitvar
-
-    real zstophym
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    TYPE(ctrl_out)                   :: var
+
+    REAL zstophym
+    CHARACTER(LEN=20) :: typeecrit
+
+    ! ug On récupère le type écrit de la structure:
+    !       Assez moche, à refaire si meilleure méthode...
+    IF (INDEX(var%type_ecrit(iff), "once") > 0) THEN
+       typeecrit = 'once'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_min") > 0) THEN
+       typeecrit = 't_min(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_max") > 0) THEN
+       typeecrit = 't_max(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "inst") > 0) THEN
+       typeecrit = 'inst(X)'
+    ELSE
+       typeecrit = type_ecri_files(iff)
+    ENDIF
+
+    IF (typeecrit=='inst(X)'.OR.typeecrit=='once') THEN
+       zstophym=zoutm(iff)
+    ELSE
+       zstophym=zdtime
+    ENDIF
 
     ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
-    call conf_physoutputs(nomvar,flag_var)
-
-    if (type_ecri(iff)=='inst(X)'.OR.type_ecri(iff)=='once') then
+    CALL conf_physoutputs(var%name, var%flag)
+
+    IF(.NOT.clef_stations(iff)) THEN  
+       IF ( var%flag(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               iim,jj_nb,nhorim(iff), 1,1,1, -99, 32, &
+               typeecrit, zstophym,zoutm(iff))                
+       ENDIF
+    ELSE
+       IF ( var%flag(iff)<=lev_files(iff)) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               npstn,1,nhorim(iff), 1,1,1, -99, 32, &
+               typeecrit, zstophym,zoutm(iff))                
+       ENDIF
+    ENDIF
+
+    ! Set swaero_diag=true if at least one of the concerned variables are defined 
+    IF (var%name=='topswad' .OR. var%name=='topswai' .OR. var%name=='solswad' .OR. var%name=='solswai' ) THEN
+       IF  ( var%flag(iff)<=lev_files(iff) ) THEN
+          swaero_diag=.TRUE.
+       END IF
+    END IF
+  END SUBROUTINE histdef2d
+
+  SUBROUTINE histdef3d_old (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
+
+    USE ioipsl
+    USE dimphy
+    USE mod_phys_lmdz_para
+    USE iophy
+
+    IMPLICIT NONE
+
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+!    INCLUDE "indicesol.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    LOGICAL                          :: lpoint
+    INTEGER, DIMENSION(nfiles)       :: flag_var
+    CHARACTER(LEN=20)                 :: nomvar
+    CHARACTER(LEN=*)                 :: titrevar
+    CHARACTER(LEN=*)                 :: unitvar
+
+    REAL zstophym
+
+    ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
+    CALL conf_physoutputs(nomvar,flag_var)
+
+    IF (type_ecri(iff)=='inst(X)'.OR.type_ecri(iff)=='once') THEN
        zstophym=zoutm(iff)
-    else
+    ELSE
        zstophym=zdtime
-    endif
-
-    if(.NOT.lpoint) THEN
-       if ( flag_var(iff)<=lev_files(iff) ) then
-          call histdef (nid_files(iff), nomvar, titrevar, unitvar, &
+    ENDIF
+
+    IF(.NOT.lpoint) THEN
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), nomvar, titrevar, unitvar, &
                iim, jj_nb, nhorim(iff), klev, levmin(iff), &
                levmax(iff)-levmin(iff)+1, nvertm(iff), 32, type_ecri(iff), &
                zstophym, zoutm(iff))
-       endif
-    else
-       if ( flag_var(iff)<=lev_files(iff) ) then
-          call histdef (nid_files(iff), nomvar, titrevar, unitvar, &
+       ENDIF
+    ELSE
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), nomvar, titrevar, unitvar, &
                npstn,1,nhorim(iff), klev, levmin(iff), &
                levmax(iff)-levmin(iff)+1, nvertm(iff), 32, &
                type_ecri(iff), zstophym,zoutm(iff))
-       endif
-    endif
-  end subroutine histdef3d
+       ENDIF
+    ENDIF
+  END SUBROUTINE histdef3d_old
+
+  SUBROUTINE histdef3d (iff,var)
+
+    USE ioipsl
+    USE dimphy
+    USE mod_phys_lmdz_para
+    USE iophy
+
+    IMPLICIT NONE
+
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    TYPE(ctrl_out)                   :: var
+
+    REAL zstophym
+    CHARACTER(LEN=20) :: typeecrit
+
+    ! ug On récupère le type écrit de la structure:
+    !       Assez moche, à refaire si meilleure méthode...
+    IF (INDEX(var%type_ecrit(iff), "once") > 0) THEN
+       typeecrit = 'once'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_min") > 0) THEN
+       typeecrit = 't_min(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_max") > 0) THEN
+       typeecrit = 't_max(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "inst") > 0) THEN
+       typeecrit = 'inst(X)'
+    ELSE
+       typeecrit = type_ecri_files(iff)
+    ENDIF
+
+
+    ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
+    CALL conf_physoutputs(var%name,var%flag)
+
+    IF (typeecrit=='inst(X)'.OR.typeecrit=='once') THEN
+       zstophym=zoutm(iff)
+    ELSE
+       zstophym=zdtime
+    ENDIF
+
+    IF(.NOT.clef_stations(iff)) THEN
+       IF ( var%flag(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               iim, jj_nb, nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, typeecrit, &
+               zstophym, zoutm(iff))
+       ENDIF
+    ELSE
+       IF ( var%flag(iff)<=lev_files(iff)) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               npstn,1,nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, &
+               typeecrit, zstophym,zoutm(iff))
+       ENDIF
+    ENDIF
+  END SUBROUTINE histdef3d
 
   SUBROUTINE conf_physoutputs(nam_var,flag_var)
@@ -1940,10 +1077,10 @@
     include 'iniprint.h'
 
-    character(len=20)                :: nam_var
-    integer, dimension(nfiles)      :: flag_var
+    CHARACTER(LEN=20)                :: nam_var
+    INTEGER, DIMENSION(nfiles)      :: flag_var
 
     IF(prt_level>10) WRITE(lunout,*)'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
-    call getin('flag_'//nam_var,flag_var)
-    call getin('name_'//nam_var,nam_var)
+    CALL getin('flag_'//nam_var,flag_var)
+    CALL getin('name_'//nam_var,nam_var)
     IF(prt_level>10) WRITE(lunout,*)'Apres getin: nam_var flag_var ',nam_var,flag_var(:)
 
@@ -1957,7 +1094,7 @@
     IMPLICIT NONE
 
-    character(len=20)   :: str
-    character(len=10)   :: type
-    integer             :: ipos,il
+    CHARACTER(LEN=20)   :: str
+    CHARACTER(LEN=10)   :: type
+    INTEGER             :: ipos,il
     real                :: ttt,xxx,timestep,dayseconde,dtime
     parameter (dayseconde=86400.)
@@ -1966,30 +1103,30 @@
     include "iniprint.h"
 
-    ipos=scan(str,'0123456789.',.true.)
+    ipos=scan(str,'0123456789.',.TRUE.)
     !  
     il=len_trim(str)
-    write(lunout,*)ipos,il
+    WRITE(lunout,*)ipos,il
     read(str(1:ipos),*) ttt
-    write(lunout,*)ttt
+    WRITE(lunout,*)ttt
     type=str(ipos+1:il)
 
 
-    if ( il == ipos ) then
+    IF ( il == ipos ) then
        type='day'
     endif
 
-    if ( type == 'day'.or.type == 'days'.or.type == 'jours'.or.type == 'jour' ) timestep = ttt * dayseconde
-    if ( type == 'mounths'.or.type == 'mth'.or.type == 'mois' ) then
-       write(lunout,*)'annee_ref,day_ref mon_len',annee_ref,day_ref,mth_len
+    IF ( type == 'day'.or.type == 'days'.or.type == 'jours'.or.type == 'jour' ) timestep = ttt * dayseconde
+    IF ( type == 'mounths'.or.type == 'mth'.or.type == 'mois' ) then
+       WRITE(lunout,*)'annee_ref,day_ref mon_len',annee_ref,day_ref,mth_len
        timestep = ttt * dayseconde * mth_len
     endif
-    if ( type == 'hours'.or.type == 'hr'.or.type == 'heurs') timestep = ttt * dayseconde / 24.
-    if ( type == 'mn'.or.type == 'minutes'  ) timestep = ttt * 60.
-    if ( type == 's'.or.type == 'sec'.or.type == 'secondes'   ) timestep = ttt
-    if ( type == 'TS' ) timestep = ttt * dtime
-
-    write(lunout,*)'type =      ',type
-    write(lunout,*)'nb j/h/m =  ',ttt
-    write(lunout,*)'timestep(s)=',timestep
+    IF ( type == 'hours'.or.type == 'hr'.or.type == 'heurs') timestep = ttt * dayseconde / 24.
+    IF ( type == 'mn'.or.type == 'minutes'  ) timestep = ttt * 60.
+    IF ( type == 's'.or.type == 'sec'.or.type == 'secondes'   ) timestep = ttt
+    IF ( type == 'TS' ) timestep = ttt * dtime
+
+    WRITE(lunout,*)'type =      ',type
+    WRITE(lunout,*)'nb j/h/m =  ',ttt
+    WRITE(lunout,*)'timestep(s)=',timestep
 
   END SUBROUTINE convers_timesteps
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 1795)
@@ -14,7 +14,47 @@
       REAL, SAVE, ALLOCATABLE :: snow_o(:), zfra_o(:)
 !$OMP THREADPRIVATE(snow_o, zfra_o)
-      INTEGER, save, ALLOCATABLE ::  itau_con(:)       ! Nombre de pas ou rflag <= 1
+      INTEGER, SAVE, ALLOCATABLE ::  itau_con(:)       ! Nombre de pas ou rflag <= 1
 !$OMP THREADPRIVATE(itau_con)
+      REAL, ALLOCATABLE :: bils_ec(:) ! Contribution of energy conservation
+      REAL, ALLOCATABLE :: bils_tke(:) ! Contribution of energy conservation
+      REAL, ALLOCATABLE :: bils_diss(:) ! Contribution of energy conservation
+      REAL, ALLOCATABLE :: bils_kinetic(:) ! bilan de chaleur au sol, kinetic
+      REAL, ALLOCATABLE :: bils_enthalp(:) ! bilan de chaleur au sol
+      REAL, ALLOCATABLE :: bils_latent(:) ! bilan de chaleur au sol
+!$OMP THREADPRIVATE(bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
 
+! ug Plein de variables venues de phys_output_mod
+      INTEGER, PARAMETER                           :: nfiles = 6
+      LOGICAL, DIMENSION(nfiles), SAVE             :: clef_files
+      LOGICAL, DIMENSION(nfiles), SAVE             :: clef_stations
+      INTEGER, DIMENSION(nfiles), SAVE             :: lev_files
+      INTEGER, DIMENSION(nfiles), SAVE             :: nid_files
+      INTEGER, DIMENSION(nfiles), SAVE  :: nnid_files
+!$OMP THREADPRIVATE(clef_files, clef_stations, lev_files,nid_files,nnid_files)
+      INTEGER, DIMENSION(nfiles), SAVE :: nnhorim
+
+      INTEGER, DIMENSION(nfiles), SAVE :: nhorim, nvertm
+      INTEGER, DIMENSION(nfiles), SAVE :: nvertap, nvertbp, nvertAlt
+      REAL, DIMENSION(nfiles), SAVE                :: zoutm
+      CHARACTER(LEN=20), DIMENSION(nfiles), SAVE   :: type_ecri
+!$OMP THREADPRIVATE(nnhorim, nhorim, nvertm, zoutm,type_ecri)
+      CHARACTER(LEN=20), DIMENSION(nfiles), SAVE  :: type_ecri_files, phys_out_filetypes
+!$OMP THREADPRIVATE(type_ecri_files, phys_out_filetypes)
+
+ ! swaero_diag : flag indicates if it is necessary to do calculation for some aerosol diagnostics
+      LOGICAL, SAVE                                :: swaero_diag=.FALSE.
+!$OMP THREADPRIVATE(swaero_diag)
+
+      INTEGER, SAVE:: levmin(nfiles) = 1
+      INTEGER, SAVE:: levmax(nfiles)
+!$OMP THREADPRIVATE(levmin, levmax)
+
+  TYPE ctrl_out
+     INTEGER,DIMENSION(nfiles)            :: flag
+     CHARACTER(len=20)                    :: name
+     CHARACTER(len=150)                   :: description
+     CHARACTER(len=20)                    :: unit
+     CHARACTER(len=20),DIMENSION(nfiles)  :: type_ecrit
+  END TYPE ctrl_out
 CONTAINS
 
@@ -27,4 +67,5 @@
       allocate(snow_o(klon), zfra_o(klon))
       allocate(itau_con(klon))
+      allocate (bils_ec(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
 
 END SUBROUTINE phys_output_var_init
@@ -36,4 +77,5 @@
 
       deallocate(snow_o,zfra_o,itau_con)
+      deallocate (bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
 
 END SUBROUTINE phys_output_var_end
